#include "VC_ex.h"
#include "MOU.h"

#define EQ_FILLA 0x8
#define EQ_CLEAR 0x7
#define EQ_FILL 0x6
#define EQ_FILLA 0x5
#define EQ_RECT 0x4
#define EQ_CIRCLE 0x3
#define EQ_LINE 0x2
#define EQ_PENCIL 0x1
#define EQ_NONE 0x0

typedef struct {
	WORD x;
	WORD y;
	WORD lx;
	WORD ly;
	WORD state;
	union
	{
		DWORD type;//e.g. Ok or Cancel
		char text[10];
	} reserved;
} Button;

typedef struct {
	WORD x;
	WORD y;
	WORD lx;
	WORD ly;
	WORD maxChars;
	WORD p;
	char text[50];

}  Edit;

typedef struct {
	WORD x;
	WORD y;
	WORD lx;
	WORD ly;
	DWORD style;
	char* caption;
} Window;

typedef struct {
	WORD x;
	WORD y;
	WORD lx;
	WORD ly;
	DWORD cur_equipment;
} Canvas;


static DWORD replaced[16*16];
static mflg = 0;
static DWORD color = 0xF0F000;

int hited( WORD* rect, int x, int y )
{
	return ( (rect[0] < x) && ((rect[0] + rect[2]) > x)) && ( (rect[1] < y) && ((rect[1] + rect[3]) > y));
}
DWORD hexToDWORD( char* s )
{
	DWORD result = 0;
	while ( *s )
	{
		result*=16;
		if ( *s >= '0' && *s <= '9' )
			result += *s - '0';
		else
			result += *s - 'A' + 10;
		s++;
	}
	return result;
}
char _ToUpper( char c )
{
	if ( c >= 'a' && c <= 'z' )
		return c - 'a' + 'A';
	return c;
}
void DrawCursor(WORD x, WORD y, BYTE var)
{
	static WORD lx, ly;
	WORD i, j;
	if ( !var )
	{
		if ( mflg )
		{
			for( i = 0; i< 16 && (i + lx < ScreenWidth); i++ )
				for( j = 0; j < 16 && (ly + j < ScreenHeight); j++ )
				{
					if ( cursor[ j*16 + i] )
					{
						PutPixel( lx + i, ly + j, replaced[ i*16 + j ] ,0 );
					}
				}
		}
		else 
			mflg = 1;
	}
	else
	{
		for( i = 0; i< 16 && (i + x < ScreenWidth); i++ )
			for( j = 0; j < 16 && (y + j < ScreenHeight); j++ )
			{
				if ( cursor[ j*16 + i] )
				{
					replaced[ i*16 + j] = GetPixel( x + i, y + j);
					PutPixel( x + i, y + j, ~replaced[ i*16 + j],0);//(cursor[ j*16 + i] == 1)?0xFF1F1F1F:0xFFFFFFFF );
				}
			}	
		lx = x;
		ly = y;
	}

}

void DrawEdit( Edit* ed )
{
	//0xBFBFBF
	WORD i;
	for( i = ed->y + 1; i < (ed->y + ed->ly - 1); i++ )
		DrawLine( ed->x, i, ed->x + ed->lx, i, 0xF1F1F1,0 );
	for( i = 0; i < 2; i++ )
	{
		DrawLine( ed->x + i,          ed->y + i,          ed->x + ed->lx - i, ed->y + i,          0xBFBFBFUL,0 );
		DrawLine( ed->x + i,          ed->y + ed->ly - i, ed->x + ed->lx - i, ed->y + ed->ly - i, 0xBFBFBFUL,0 );
		DrawLine( ed->x + i,          ed->y + i,          ed->x + i,          ed->y + ed->ly - i, 0xBFBFBFUL,0 );
		DrawLine( ed->x + ed->lx - i, ed->y + i,          ed->x + ed->lx - i, ed->y + ed->ly - i, 0xBFBFBFUL,0 );
	}
	writeText( ed->x + 2, ed->y + 2, ed->text, 0x0UL );
}
void DrawButton( Button *bt)
{
	WORD i, j;

	for( i = 0; i < 3; i++ )
	{
		DrawLine( bt->x + i,			bt->y + i,			bt->x + bt->lx - i, bt->y + i,			0x5F5F5FUL,0 );
		DrawLine( bt->x + i,			bt->y + bt->ly - i, bt->x + bt->lx - i, bt->y + bt->ly - i, 0x5F5F5FUL,0 );
		DrawLine( bt->x + i,			bt->y + i,			bt->x + i,			bt->y + bt->ly - i, 0x5F5F5FUL,0 );
		DrawLine( bt->x + bt->lx - i,	bt->y + i,			bt->x + bt->lx - i, bt->y + bt->ly - i, 0x5F5F5FUL,0 );
	}

	if ( bt->state )
	{
		for( i = bt->x + 3; i < (bt->x + bt->lx - 1); i++ )
			for( j = bt->y + 3; j < (bt->y + bt->ly - 1); j++ )
				PutPixel( i, j, 0x8F8F8FUL,0 );
	}
	else
	{
		for( i = bt->x + 2; i < (bt->x + bt->lx - 2); i++ )
			for( j = bt->y + 2; j < (bt->y + bt->ly - 2); j++ )
				PutPixel( i, j, 0xC5C4C3UL,0 );
	}

	if ( !(bt->reserved.text[0]) )
	{
		if ( bt->state )
			writeText( bt->x  + 5, bt->y + 1, &(bt->reserved.text[1]), 0x0UL );
		else
			writeText( bt->x  + 3  , bt->y + 0, &(bt->reserved.text[1]), 0x0UL );
	}
	else
	{
		switch( bt->reserved.type )
		{
		case 1://btOK
			writeText( bt->x + (bt->lx >> 1 ) - 8 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "OK", 0x0UL );
			break;
		case 2://CANCEL
			writeText( bt->x + (bt->lx >> 1) - 24 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "CANCEL", 0x0UL );
			break;
		case 3://SAVE
			writeText( bt->x + (bt->lx >> 1 ) - 16 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "SAVE", 0x0UL );
			break;
		case 4:
			writeText( bt->x + (bt->lx >> 1 ) - 16 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "LOAD", 0x0UL );
			break;
		case 5:
			writeText( bt->x + (bt->lx >> 1 ) - 24 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "PENCIL", 0x0UL );
			break;
		case 6:
			writeText( bt->x + (bt->lx >> 1 ) - 16 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "LINE", 0x0UL );
			break;
		case 7:
			writeText( bt->x + (bt->lx >> 1 ) - 24 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "CIRCLE", 0x0UL );
			break;
		case 8:
			writeText( bt->x + (bt->lx >> 1 ) - 16 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "RECT", 0x0UL );
			break;
		case 9:
			writeText( bt->x + (bt->lx >> 1 ) - 16 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "POLY", 0x0UL );
			break;
		case 10:
			writeText( bt->x + (bt->lx >> 1 ) - 16 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "FILL", 0x0UL );
			break;
		case 11:
			writeText( bt->x + (bt->lx >> 1 ) - 20 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "CLEAR", 0x0UL );
			break;
		case 12:
			writeText( bt->x + (bt->lx >> 1 ) - 20 + ((!bt->state)?(0):(2)), bt->y + (bt->ly>>1) - 8 + ((!bt->state)?(0):(2)), "FILL*", 0x0UL );
			break;
		}
	}
   
}

void ProcessGraph()
{
	WORD delay = 0;

	BYTE buf = 0;
	WORD X = -1, Y = -1, Xb = -1, Yb = -1;
	int MX, MY;
	WORD flg = 1;
	Edit edColor, edFilename, *FOCUS = &edFilename;
	Button btEscape, btLoad, btSave, btPencil, btLine, btCircle, btRect, btFill, btClear, btFillA;
	Canvas canvas;
	mflg = 0;

	canvas.x = 161;
	canvas.lx = 628;
	canvas.y = 111;
	canvas.ly = 468;
	canvas.cur_equipment = EQ_NONE;

	btEscape.x = 775;
	btEscape.y = 2;
	btEscape.lx = 16;
	btEscape.ly = 16;
	btEscape.state = 0;
	btEscape.reserved.text[0] = 0;
	btEscape.reserved.text[1] = 'X';
	btEscape.reserved.text[2] = 0;

	edFilename.x = 104;
	edFilename.y = 32;
	edFilename.ly = 20;
	edFilename.lx = 420;
	edFilename.maxChars = 50;
	edFilename.text[0] = 0;
	edFilename.p = 0;

	edColor.x = 70;
	edColor.y = 124;
	edColor.ly = 20;
	edColor.lx = 52;
	edColor.maxChars = 7;
	edColor.text[0] = 0;
	edColor.p = 0;

	btPencil.x = 24;
	btPencil.y = 260;
	btPencil.ly = 20;
	btPencil.lx = 52;
	btPencil.state = 0;
	btPencil.reserved.type = 5;

	btLine.x = 80;
	btLine.y = 260;
	btLine.ly = 20;
	btLine.lx = 52;
	btLine.state = 0;
	btLine.reserved.type = 6;

	btCircle.x = 24;
	btCircle.y = 282;
	btCircle.ly = 20;
	btCircle.lx = 52;
	btCircle.state = 0;
	btCircle.reserved.type = 7;

	btRect.x = 80;
	btRect.y = 282;
	btRect.ly = 20;
	btRect.lx = 52;
	btRect.state = 0;
	btRect.reserved.type = 8;

	btFill.x = 80;
	btFill.y = 304;
	btFill.ly = 20;
	btFill.lx = 52;
	btFill.state = 0;
	btFill.reserved.type = 10;

	btClear.x = 24;
	btClear.y = 540;
	btClear.ly = 20;
	btClear.lx = 52;
	btClear.state = 0;
	btClear.reserved.type = 11;

	btFillA.x = 80;
	btFillA.y = 540;
	btFillA.ly = 20;
	btFillA.lx = 52;
	btFillA.state = 0;
	btFillA.reserved.type = 12;
	
	btLoad.x = 530;
	btLoad.lx = 50;
	btLoad.y = 32;
	btLoad.ly = 20;
	btLoad.reserved.type = 4;
	btLoad.state = 0;

	btSave.x = 590;
	btSave.lx = 50;
	btSave.y = 32;
	btSave.ly = 20;
	btSave.reserved.type = 3;
	btSave.state = 0;

	MOUinit();

	MX = X = mousex;
	MY = Y = mousey;
	{
		WORD i;
		for( i = 0; i < 600; i++ )
			DrawLine( 0, i, 800, i, 0xAFAFAFUL,0 );

		for( i = 0; i < 2; i++ )
		{
			DrawLine( i,       i,       800 - i, i,       0x0UL,0 );
			DrawLine( i,       600 - i, 800 - i, 600 - i, 0x0UL,0 );
			DrawLine( i,       i,       i,       600 - i, 0x0UL,0 );
			DrawLine( 800 - i, i,       800 - i, 600 - i, 0x0UL,0 );
		}
		for( i = 0; i < 20; i++ )
			DrawLine( 0, i, ScreenWidth, i, 0x4671F4,0 );
		writeText( 0, 0, "PAINT FOR MSDOS V 3.5", 0x9F0006UL );

		for( i = 0; i < 2; i++ )
		{
			DrawLine( 10 + i,       30 + i,       790 - i, 30 + i,  0x0UL,0 );
			DrawLine( 10 + i,       100 - i,      790 - i, 100 - i, 0x0UL,0 );
			DrawLine( 10 + i,       30 + i,       10 + i,  100 - i, 0x0UL,0 );
			DrawLine( 790 - i,		30 + i,		  790 - i, 100 - i, 0x0UL,0 );
		}

		for( i = 0; i < 2; i++ )
		{
			DrawLine( 10 + i,       110 + i,      150 - i, 110 + i,  0x0UL,0 );
			DrawLine( 10 + i,       580 - i,      150 - i, 580 - i, 0x0UL,0 );
			DrawLine( 10 + i,       110 + i,      10 + i,  580 - i, 0x0UL,0 );
			DrawLine( 150 - i,		110 + i,	  150 - i, 580 - i, 0x0UL,0 );
		}
			for( i = 0; i < 2; i++ )
			{
				DrawLine( 20 + i,       120 + i,      140 - i, 120 + i,  0x0UL,0 );
				DrawLine( 20 + i,       220 - i,      140 - i, 220 - i, 0x0UL,0 );
				DrawLine( 20 + i,       120 + i,      20 + i,  220 - i, 0x0UL,0 );
				DrawLine( 140 - i,		120 + i,	  140 - i, 220 - i, 0x0UL,0 );
			}
			writeText( 24, 124, "COLOR", 0x0UL );
			for( i = 170; i < 210; i++ )
				DrawLine( 40, i, 130, i, color,0 );

			for( i = 0; i < 2; i++ )
			{
				DrawLine( 20 + i,       230 + i,      140 - i, 230 + i,  0x0UL,0 );
				DrawLine( 20 + i,       570 - i,      140 - i, 570 - i, 0x0UL,0 );
				DrawLine( 20 + i,       230 + i,      20 + i,  570 - i, 0x0UL,0 );
				DrawLine( 140 - i,		230 + i,	  140 - i, 570 - i, 0x0UL,0 );
			}
			writeText( 24, 234, "TOOLS", 0x0UL );

		for( i = 0; i < 2; i++ )
		{
			DrawLine( 160 + i,       110 + i,      790 - i, 110 + i,  0x0UL,0 );
			DrawLine( 160 + i,       580 - i,      790 - i, 580 - i, 0x0UL,0 );
			DrawLine( 160 + i,       110 + i,      160 + i,  580 - i, 0x0UL,0 );
			DrawLine( 790 - i,		 110 + i,	  790 - i, 580 - i, 0x0UL,0 );
		}
		for( i = 111; i < 580; i++ )
			DrawLine( 161, i, 789, i, 0xFFFFFFUL,0 );

		writeText( 14, 34, "FILE NAME:", 0x0UL ); 
	}

	DrawButton( &btEscape );
	DrawButton( &btLoad );
	DrawButton( &btSave );
	DrawButton( &btPencil );
	DrawButton( &btLine );
	DrawButton( &btClear );
	DrawButton( &btCircle );
	DrawButton( &btRect );
	DrawButton( &btFill );
	DrawButton( &btFillA );

	DrawEdit( &edFilename );
	DrawEdit( &edColor );

	while ( flg )
	{
		MX = mousex;
		MY = mousey;
		if (kbhit() )
		{
			buf = getch();
			switch( buf )
			{
			case 27:
				flg = 0;
				break;
			case 8:
				if ( FOCUS->p )
				{
					(FOCUS->p)--;
					FOCUS->text[FOCUS->p] = 0;
				}
				break;
			case 13:
				break;
			case 9:
				if ( FOCUS == &edFilename )
					FOCUS = &edColor;
				else
					FOCUS = &edFilename;
			case 224:
				getch();
				buf = 0;
				break;
			default:
				if ( FOCUS == &edColor )
					if ( !( (buf >= '0' && buf <= '9') || ( _ToUpper(buf) >= 'A' && _ToUpper(buf) <= 'F' ) ) )
						break;//    ,   
				if ( FOCUS->p < (FOCUS->maxChars - 1) )
				{
					FOCUS->text[FOCUS->p] = _ToUpper(buf);
					(FOCUS->p)++;
					FOCUS->text[FOCUS->p] = 0;
				}
			}
			DrawEdit( FOCUS );
			if ( FOCUS == &edColor )
			{
				int i = 0;
				color = hexToDWORD( edColor.text );
				for( i = 170; i < 210; i++ )
					DrawLine( 40, i, 130, i, color,0 );
			}
		}

		if ( (MOUbuttonstatus() & 1) && delay > 20000 )
		{
			if ( hited( (WORD*)&canvas, MX, MY ) )
			{
				switch( canvas.cur_equipment )
				{
				case EQ_PENCIL:
					PutPixel( MX, MY, color,1 );
					break;
				case EQ_LINE:
					if ( ( Xb > canvas.x && Xb < ( canvas.x + canvas.lx ) ) && (Yb > canvas.y && Yb < ( canvas.y + canvas.ly ) ))
					{
						DrawCursor( 0, 0, 0 );//remove cursor
						DrawLine( Xb, Yb, MX, MY, color,1 );
						DrawCursor( X, Y, 1 );// and  then draw in new place		
					}
					break;
				case EQ_CIRCLE:
					if ( ( Xb > canvas.x && Xb < ( canvas.x + canvas.lx ) ) && (Yb > canvas.y && Yb < ( canvas.y + canvas.ly ) ))
					{
						DrawCursor( 0, 0, 0 );//remove cursor
						DrawCircle( Xb, Yb, sqrt( (MX - Xb)*(MX - Xb) + (MY - Yb)*(MY - Yb) ), color );//( Xb, Yb, MX, MY, color,1 );
						DrawCursor( X, Y, 1 );// and  then draw in new place	
					}
					break;
				case EQ_RECT:
					if ( ( Xb > canvas.x && Xb < ( canvas.x + canvas.lx ) ) && (Yb > canvas.y && Yb < ( canvas.y + canvas.ly ) ))
					{
						DrawCursor( 0, 0, 0 );//remove cursor
						DrawLine( Xb, Yb, MX, Yb, color, 1);
						DrawLine( Xb, MY, MX, MY, color, 1);
						DrawLine( Xb, Yb, Xb, MY, color, 1);
						DrawLine( MX, Yb, MX, MY, color, 1);
						DrawCursor( X, Y, 1 );// and  then draw in new place	
					}
					break;
				case EQ_FILL:
					DrawCursor( 0, 0, 0 );//remove cursor
					{
						POINTXYI stack[6000];
						WORD cnt = 1;
						char ib = 0;
						DWORD rplColor = GetPixel( MX, MY );
						WORD X, Y;
						stack->x = MX;
						stack->y = MY;
						do
						{
							X = stack[cnt - 1].x;
							Y = stack[cnt - 1].y;
							ib = stack[cnt - 1].i;
							cnt--;
							PutPixel(  X, Y, color, 1 );
							if ( GetPixel( X, Y - 1) == rplColor && ib )
							{
								stack[cnt].i = 0;
								stack[cnt].x = X;
								stack[cnt++].y = Y - 1;
								if ( cnt == 6000 )
									continue;
							}
							if ( GetPixel( X - 1, Y) == rplColor && ib != 1 )
							{
								stack[cnt].i = 1;
								stack[cnt].x = X - 1;
								stack[cnt++].y = Y;
								if ( cnt == 6000 )
									continue;
							}
							if ( GetPixel( X, Y  + 1) == rplColor && ib != 2)
							{
								stack[cnt].i = 2;
								stack[cnt].x = X;
								stack[cnt++].y = Y + 1;
								if ( cnt == 6000 )
									continue;
							}
							if ( GetPixel( X + 1, Y) == rplColor && ib != 3)
							{
								stack[cnt].i = 3;
								stack[cnt].x = X + 1;
								stack[cnt++].y = Y;
							}
						}
						while ( cnt && rplColor != color );
					}
					DrawCursor( X, Y, 1 );// and  then draw in new place
					break;
				case EQ_FILLA:
					DrawCursor( 0, 0, 0 );//remove cursor
					{
						DWORD cl = GetPixel( MX, MY );
						int i, j;
						for( i = 111; i < 468 + 1 + 111; i++ )
							for( j = 161; j < 161 + 628 + 1; j++ )
								if ( GetPixel( j, i ) == cl )
									PutPixel( j, i, color, 1 );
					}
					DrawCursor( X, Y, 1 );// and  then draw in new place
				}
				Xb = MX;
				Yb = MY;
			}
			else if ( hited( (WORD*)&btEscape, MX, MY ) )
			{
				DrawCursor( 0, 0, 0 );//remove cursor
				btEscape.state = 1;
				DrawButton( &btEscape );
				for( flg = 0; flg < 10000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				btEscape.state = 0;
				DrawButton( &btEscape );
				for( flg = 0; flg < 10000; flg++, flg += 123127.23423f*2323423.23423f*23423.023f*0 );
				flg = 0;
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btLoad, MX, MY ) )
			{
				DrawCursor( 0, 0, 0 );//remove cursor
				btLoad.state = 1;
				DrawButton( &btLoad );
				LoadBMP( (POINTXY*)&canvas, edFilename.text, 0 ); 
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				btLoad.state = 0;
				DrawButton( &btLoad );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}			
			else if ( hited( (WORD*)&btSave, MX, MY ) )
			{
				DrawCursor( 0, 0, 0 );//remove cursor
				btSave.state = 1;
				DrawButton( &btSave );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				SaveBMP( edFilename.text );
				btSave.state = 0;
				DrawButton( &btSave );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btPencil, MX, MY ) )
			{
				DrawCursor( 0, 0, 0 );//remove cursor
				btPencil.state = 1;
				DrawButton( &btPencil );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				canvas.cur_equipment = EQ_PENCIL;
				Xb = 0;
				Yb = 0;
				btPencil.state = 0;
				DrawButton( &btPencil );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btLine, MX, MY ) )
			{
				DrawCursor( 0, 0, 0 );//remove cursor
				btLine.state = 1;
				DrawButton( &btLine );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				canvas.cur_equipment = EQ_LINE;
				Xb = 0;
				Yb = 0;
				btLine.state = 0;
				DrawButton( &btLine );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btClear, MX, MY ) )
			{
				int i = 0;
				DrawCursor( 0, 0, 0 );//remove cursor
				btClear.state = 1;
				DrawButton( &btClear );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				for( i = 111; i < 580; i++ )
					DrawLine( 161, i, 789, i, 0xFFFFFFUL,0 );
				Xb = 0;
				Yb = 0;
				btClear.state = 0;
				DrawButton( &btClear );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btCircle, MX, MY ) )
			{
				int i = 0;
				DrawCursor( 0, 0, 0 );//remove cursor
				btCircle.state = 1;
				DrawButton( &btCircle );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				canvas.cur_equipment = EQ_CIRCLE;
				Xb = 0;
				Yb = 0;
				btCircle.state = 0;
				DrawButton( &btCircle );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btRect, MX, MY ) )
			{
				int i = 0;
				DrawCursor( 0, 0, 0 );//remove cursor
				btRect.state = 1;
				DrawButton( &btRect );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				canvas.cur_equipment = EQ_RECT;
				Xb = 0;
				Yb = 0;
				btRect.state = 0;
				DrawButton( &btRect );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btFill, MX, MY ) )
			{
				int i = 0;
				DrawCursor( 0, 0, 0 );//remove cursor
				btFill.state = 1;
				DrawButton( &btFill );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				canvas.cur_equipment = EQ_FILL;
				Xb = 0;
				Yb = 0;
				btFill.state = 0;
				DrawButton( &btFill );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&btFillA, MX, MY ) )
			{
				DrawCursor( 0, 0, 0 );//remove cursor
				btFillA.state = 1;
				DrawButton( &btFillA );
				for( flg = 0; flg < 50000; flg++, flg += 123127.23423f*2323423.23423f*23423.032f*0 );
				Xb = 0;
				Yb = 0;
				canvas.cur_equipment = EQ_FILLA;
				btFillA.state = 0;
				DrawButton( &btFillA );
				DrawCursor( X, Y, 1 );// and  then draw in new place
				delay = 0;
			}
			else if ( hited( (WORD*)&edFilename, MX, MY ) )
			{
				FOCUS = &edFilename;
			}			
			else if ( hited( (WORD*)&edColor, MX, MY ) )
			{
				FOCUS = &edColor;
			}
		}	

		if ( X != MX  || Y != MY )
		{
			X = MX;
			Y = MY;
			DrawCursor( 0, 0, 0 );//remove cursor
			DrawCursor( X, Y, 1 );// and  then draw in new place
		}
		delay++;
	}
	MOUdeinit();
}